# -*- coding: utf-8 -*-
from setuphelpers import *

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()
{
   "key":"FreePascal_is1",
   "name":"Free Pascal 3.2.2",
   "version":"",
   "install_date":"2024-06-05 00:00:00",
   "install_location":"C:\\FPC\\3.2.2\\",
   "uninstall_string":"\"C:\\FPC\\3.2.2\\unins000.exe\"",
   "publisher":"Free Pascal Team",
   "system_component":0,
   "win64":false
  }

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def install():
    # Declaring local variables
    bin_name = glob.glob("fpc-*.win32.and.win64.exe")[0]
            
    # Installing the software
    
    install_exe_if_needed(bin_name,
        silentflags='/VERYSILENT /SUPPRESSMSGBOXES /NORESTART',
        key= 'FreePascal_is1',
        min_version =control.get_software_version() ,
        get_version=get_version,
        timeout=600,
    )


def get_version(app_registry_dict):

    return app_registry_dict["name"][12:]

